%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Dynamic Syntax
%
% input/output library
%
% Matthew Purver, 2002
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

:- use_module( library( sockets ) ).


% initialisation
startup( _Socket ) :-
	io( term ).
startup( Socket ) :-
	io( sock ),
	socket( 'AF_INET', Socket ),
	socket_bind( Socket, 'AF_INET'( localhost, Port ) ),
	open( 'port.txt', write, PortFileStream ),
	print( PortFileStream, Port ), nl( PortFileStream ),
	close( PortFileStream ),
	socket_listen( Socket, 1 ).

% shutdown
shutdown( _Socket ) :-
	io( term ),
	newline, print( 'Goodbye!' ), newline,
	abort.
shutdown( Socket ) :-
	io( sock ),
	newline, print( 'Goodbye!' ), newline,
	current_output( Stream ),
	close( Stream ),
	socket_close( Socket ),
	halt.

get_input( _Socket, Words ) :-
	io( term ),
	write( 'ds> ' ), flush_output,
	read_in( Words ).
get_input( Socket, Words ) :-
	io( sock ),
	socket_accept( Socket, _Client, SockStream ),
	set_input( SockStream ),
	set_output( SockStream ),
	read_in( Words ).
